/***** BEGIN LICENSE BLOCK *****
    FlashGot - a Firefox extension for external download managers integration
    Copyright (C) 2004-2005 Giorgio Maone - g.maone@informaction.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

***** END LICENSE BLOCK *****/
function FlashGotDMDialog() {
  flashGotDMDialog=this;

  this.url=dialog.mLauncher.source.spec;
  
  try {
      this.referrer=dialog.mContext.QueryInterface(
        Components.interfaces.nsIWebNavigation).currentURI.spec;
    } catch(ex) {
      this.referrer=this.url;
    }
    this.dialog=dialog;
    

    this.fname=dialog.mLauncher.suggestedFileName;
    var ext=this.fname.split('.');
    this.ext=ext.length>0?ext[ext.length-1]:"";
    this.extensionExists=g_flashGotService.extensionExists(this.ext);
    const fgs=g_flashGotService;
    if(fgs.DMS.found && (!fgs.bypassAutostart)
        && (fgs.forceAutostart
            || ( fgs.getPref("autoStart",true)
              && (fgs.getPref("interceptAll",false)
                  || this.extensionExists) ) )
        ) {
      this.download();
      return;
    }

  setTimeout(
    function() {
      flashGotDMDialog.init(); 
    },0);
}

FlashGotDMDialog.prototype = {
  get choosen() {
    return g_flashGotService.getPref("dmchoice",false);
  }
, 
  set choosen(v) {
    g_flashGotService.setPref("dmchoice",v);
    return v;
}
,

  init: function() {
    var remember=document.getElementById("rememberChoice");
    if(!remember) {
      remember=document.getElementById("alwaysHandle");
    }
    this.remember=remember;
    
    this.choice=document.getElementById("flashgot-dmradio");
    const dmsMenu=this.dmsMenu=document.getElementById("flashgot-dms");
    const dms=g_flashGotService.DMS;
    if(!dms.found) {
      this.choice.setAttribute("disabled","true");
      dmsMenu.setAttribute("collapsed","true");
      return;
    }
    
    

    const modeRadioGroup=document.getElementById("mode");
    const defaultDM=g_flashGotService.defaultDM; 
    
    var menuItem;
    var enabledDMSs=0;
    dmsMenu.removeAllItems();
    for(var j=0,len=dms.length; j<len; j++) {
      dm=dms[j];
      if(dm.supported) {
        enabledDMSs++;
        menuItem=dmsMenu.appendItem(dm.name,dm.codeName);
        if(defaultDM==dm.name) {
          dmsMenu.selectedItem=menuItem;
        }
      }
    }
    
    if(enabledDMSs<2) {
      dmsMenu.setAttribute("collapsed","true");
    } else {
      dmsMenu.addEventListener("popuphidden", function() {
        flashGotDMDialog.toggleChoice();
      }, true);
      // dirty hack for widths
      const radios=modeRadioGroup.getElementsByTagName("radio");
      var radioWidth=0,r;
      var patchedRadios=[];
      for(r=radios.length; r-->0;) {
        var radio=radios[r];
        if(radio.nextSibling) {
          radioWidth=Math.max(radioWidth, radio.boxObject.width);
          patchedRadios[patchedRadios.length]=radio;
        }
      }
      if(radioWidth) {
        for(r=patchedRadios.length; r-- >0;) {
          patchedRadios[r].width=radioWidth;
        }
      }
    }
    
    modeRadioGroup.addEventListener(
    "select", function(event) {
      flashGotDMDialog.toggleChoice(event)
    },true);
    
    if(this.choosen) {
      remember.checked=this.extensionExists;
      document.getElementById("mode").selectedItem=this.choice;
    }
    
    document.documentElement.setAttribute('ondialogaccept',
      'if(flashGotDMDialog.dialogAccepted()) { '
      + document.documentElement.getAttribute('ondialogaccept')
      +'}');
          
  }
,
  toggleChoice: function() {
    var mode=document.getElementById("mode");
    var dmchoice = mode.selectedItem == this.choice;
    
    this.choosen=dmchoice;
    var remember=this.remember;
    
    if(dmchoice) {
      this.dmsMenu.removeAttribute("disabled");
      window.setTimeout(
        function() { 
          document.documentElement.getButton('accept').removeAttribute('disabled');
        },10);
      if(remember) {
        this.rememberSave={ checked: remember.checked, disabled: remember.getAttribute("disabled") };
        remember.setAttribute("disabled",this.extensionExists?"true":"false");
      }
    } else {
      if(remember && this.rememberSave) { 
        remember.setAttribute("disabled",this.rememberSave.disabled);
      }
      this.dmsMenu.setAttribute("disabled",true);
    }
  }
,
   dialogAccepted: function() {
    if(this.choosen) {
      if(this.remember && this.remember.checked) {
        g_flashGotService.addExtension(this.ext);
      }
      if(this.dmsMenu.selectedItem) {
        g_flashGotService.defaultDM=this.dmsMenu.selectedItem.getAttribute("label");
      }
      this.download();
      return false;
    } else {
      return true;
    }
  }
,
  download: function() {
    var links=[ {
       href: this.url, 
       title: this.fname
    } ];
    links.referrer=this.referrer;
    
    g_flashGotService.download(links);
      
    document.documentElement.removeAttribute('ondialogaccept');
    document.documentElement.cancelDialog();
  }
}

window.addEventListener("load",  
  function(loadEv) {
    new FlashGotDMDialog();
  }, false);



