/***** BEGIN LICENSE BLOCK *****
    FlashGot - a Firefox extension for external download managers integration
    Copyright (C) 2004-2005 Giorgio Maone - g.maone@informaction.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

***** END LICENSE BLOCK *****/


function FlashGot() {
  
  try {
     //if(!g_flashGotService.getPref("lateStartup",false)) g_flashGotService.initGlobals();
    
    // install listeners
    
    window.addEventListener("mouseover", function(ev) {
      flashGot.hoverElement=ev.target;
    }, false);
    
    window.addEventListener("mouseup",function(ev) {
      g_flashGotService.bypassAutostart=false;
      g_flashGotService.forceAutostart=false;
      if(ev.altKey && !(ev.ctrlKey || ev.metaKey)) {
        function prevent() {
          ev.preventDefault();
          ev.stopPropagation();
          flashGot.lastClickCaptureTime=new Date().getTime();
        }
        if(ev.shiftKey) {
          g_flashGotService.bypassAutostart=
            g_flashGotService.getPref("bypassCombo",true);
        } else {
          if(g_flashGotService.getPref("altClick")) {
            try {
              if(flashGot.downloadSel() || flashGot.downloadLink()) {
                prevent();
                return;
              }
            } catch(ex) {}
            g_flashGotService.forceAutostart=true;
          } else {
            return;
          } 
        }
        ev2=ev.view.document.createEvent("MouseEvents");
        ev2.initMouseEvent("click",ev.canBubble, ev.cancelable, 
                           ev.view, ev.detail, ev.screenX, ev.screenY, 
                           ev.clientX, ev.clientY, 
                           //ev.ctrlKey, ev.altKey, ev.shiftKey, ev.metaKey,
                           false,false,false,false,
                           ev.button, ev.relatedTarget);
        prevent();
        flashGot.hoverElement.dispatchEvent(ev2);
      }
    }, true);
    
    window.addEventListener("click",function(ev) {
      if(ev.altKey 
        && typeof(flashGot.lastClickCaptureTime)=="number"
        && new Date().getTime()-flashGot.lastClickCaptureTime < 100
      ) {
        ev.preventDefault();
        ev.stopPropagation();
      }
    }, true);
    
    var contextMenu;;
    if(g_flashGotService.mailer || 
        ! (contextMenu=document.getElementById("contentAreaContextMenu"))
      ) {
      contextMenu=document.getElementById("messagePaneContext");
      g_flashGotService.mailer=true;
    }
    contextMenu.addEventListener(
      "popupshowing",function(ev) { flashGot.prepareContextMenu(ev); },false);
    this.toggleMainMenuIcon();
  } catch(err) {
    this.log("Unrecoverable init error: "+err.message);
  }
  
  flashGot=this;
  
}

FlashGot.prototype = {
  hoverElement: null
, 
  log: function(msg) {
    g_flashGotService.log(msg);
  }
,
  switchOption: function(opt) {
    g_flashGotService.setPref(opt,!g_flashGotService.getPref(opt));
  }
,
  openOptionsDialog: function() {
    window.openDialog("chrome://flashgot/content/flashgotOptions.xul","flashgotOptions",
      "chrome,dialog,centerscreen,alwaysRaised");
  }
,
  openAboutDialog: function() {
    window.openDialog("chrome://flashgot/content/about.xul","flashgotAbout",
      "chrome,dialog,centerscreen");
  }
,
  get hideIcons() {
    return g_flashGotService.getPref("hide-icons",false);
  }
,
  toggleIcon: function(m, hide) {
    const iconicClass=m.tagName+"-iconic";
    const rx=new RegExp("\\b"+iconicClass+"\\b");
    if(hide) {
      m.className=m.className.replace(rx,"").replace(/\bflashgot-icon-(\w+)\b/,'flashgot-noicon-$1');
    } else {
      const cl=m.className;
      if(!rx.test(cl)) {
        m.className=cl.replace(/\bflashgot-noicon-(\w+)\b/,'flashgot-icon-$1')+" "+iconicClass;
      }
    }
  }
,
  toggleMainMenuIcon: function() {
    this.toggleIcon(document.getElementById("flashgot-menu"),this.hideIcons);
  }
,
  prepareToolsMenu: function(ev) {
    function toggleMenu(id) {
      var m=document.getElementById(id);
      m.setAttribute("disabled",disabled);
      flashGot.toggleIcon(m,hideIcons);
    }
    if(!(document.getElementById("flashgot-menu").hidden=g_flashGotService.getPref("hide-menu"))) {
      const disabled=g_flashGotService.DMS.found?"false":"true";
      const hideIcons=this.hideIcons;
      toggleMenu("flashgot-main-menuitem-all");
      toggleMenu("flashgot-main-menuitem-sel");
      this.prepareOptsMenu(ev);
    }
  }
,
  prepareContextMenu: function(ev) {
    this.toggleMainMenuIcon();
    var menuCount=0;
    function menuSwitch(name, disabled) {
      var menuItem=document.getElementById("flashgot-menuitem-"+name);
      
      if(menuItem && 
        ! ( menuItem.hidden = 
            ( hidden || g_flashGotService.getPref("hide-"+name) ) )
      ) {
       menuItem.setAttribute("disabled",disabled?"true":"false");
       if(! (menuItem.hidden=disabled && hideDisabled) ) {
         menuCount++;
       }
       flashGot.toggleIcon(menuItem,hideIcons);
      }
    }
    const defaultDM=g_flashGotService.defaultDM;  
    const dms=g_flashGotService.DMS;
    var dm=dms.found?dms[defaultDM]:null;
    
    const invalidLink=!this.popupLink;
   
    const invalidSel = this.isSelInvalid;
    
    const noLink=this.linksCount==0;
    const hideDisabled=g_flashGotService.getPref("hideDisabledCmds");  
    
    var hidden=! (dms.found && dm);
    const hideIcons=this.hideIcons;  
    menuSwitch("it",  invalidLink || hidden || dm.disabledLink);
    menuSwitch("sel", invalidSel || hidden  || dm.disabledSel);
    menuSwitch("all", noLink || hidden || dm.disabledAll);
    menuSwitch("autotest", hidden);
    hidden=false;
    menuSwitch("buildGallery", invalidLink && invalidSel && noLink 
      && !this.unwrappedWindow._flashgotGB );
    
    const optsMenu=document.getElementById("flashgot-menu-options");
    
    hidden=g_flashGotService.getPref("hide-options");
    if(hidden) { 
      optsMenu.setAttribute("collapsed","true");
    } else {
      menuCount++;
      optsMenu.removeAttribute("collapsed");
    }
    document.getElementById("flashgot-context-separator").hidden=menuCount==0;
  }
,
  prepareOptsMenu: function(ev) {
    const parentNode=ev.target;
    const opts=parentNode.getElementsByTagName("menuitem");
    
    var menuItem,id,match,lastMenu=null,isTBB=false;
    var j=opts.length;
    while(j-->0) {
      menuItem=opts[j];
      if(id=menuItem.id) {
        if(match=id.match(/opt-(.*)/)) {
          menuItem.setAttribute("checked",
            g_flashGotService.getPref(match[1])?"true":"false"
            );
        } else if(match=id.match(/^flashgot-(\w+)-menuitem-nodms$/)) {
          lastMenu=menuItem;
          isTBB=match[1]=="tbb";
        }
      }
    }
    
    if(!lastMenu) return;
    
    const defaultDM=g_flashGotService.defaultDM;  
    const dms=g_flashGotService.DMS;
    var menuItemId;
    if(dms.found) {
      var idPrefix="flashgot-menuopt-dm-";
      var eventPostfix;
      if(isTBB) {
        idPrefix+="tbb-";
        eventPostfix="flashGot.downloadSel() || flashGot.downloadAll()";
      } else {
        eventPostfix="flashGot.downloadPopupLink() || flashGot.downloadSel()";
      }
      lastMenu.setAttribute("collapsed","true");
      parentNode=lastMenu.parentNode;
      
      for(j=dms.length; j-- >0;) {
        dm=dms[j];
        if(dm.supported) {
          menuItemId=idPrefix+dm.name;
          menuItem=document.getElementById(menuItemId);
          if(!menuItem) {
            menuItem=document.createElement("menuitem");
            menuItem.setAttribute("id",menuItemId);
            menuItem.setAttribute("type","radio");
            menuItem.setAttribute("autocheck","true");
            menuItem.setAttribute("oncommand","g_flashGotService.defaultDM=\""+dm.name+"\"; "+eventPostfix);
            menuItem.setAttribute("label",dm.name);
            parentNode.insertBefore(menuItem,lastMenu);
          }
          menuItem.setAttribute("checked",(defaultDM==dm.name)?"true":"false");
          lastMenu=menuItem;
        }
      }
    } else {
      lastMenu.removeAttribute("collapsed");
    }
  }
,
  get unwrappedWindow() {
    return window._content;
  }
,
  get srcWindow() {
    return new XPCNativeWrapper(document.commandDispatcher.focusedWindow, 'document','getSelection()');
  }
,
  get srcDocument() {
    return new XPCNativeWrapper(this.srcWindow.document, 'links','embeds','images','URL','referrer','cookie');
  }
,
  get isSelInvalid() {
    return this.srcWindow.getSelection().isCollapsed;
  }
,
  get popupLink() { 
    return this.findLinkAsc(document.popupNode);
  }
,
  get linksCount() {
    function len(node) {
      return new XPCNativeWrapper(node,'length').length;
    }
    const doc=this.srcDocument;
    if(! doc ) return 0;
    var count=len(doc.links);
    if(g_flashGotService.getPref("includeImages")) count+=len(doc.images);
    count+=len(doc.embeds);
    return count;
  }
,
  wrapCollection: function(coll) {
    return new XPCNativeWrapper(coll,'item()','length');
  }
,
  getLinks: function(filter,includeImages) {
    var allLinks=filterLinks(this.srcDocument.links,filter,"a");
    const urlResolver=Components.classes['@mozilla.org/network/io-service;1'].getService(
      Components.interfaces.nsIIOService).newURI(this.srcDocument.URL,null,null);
      
    if(includeImages) {
      allLinks=allLinks.concat(filterLinks(this.srcDocument.images, wrapAndFilter,"img"));
    }
    
    allLinks=allLinks.concat(filterLinks(this.srcDocument.embeds,wrapAndFilter,"embed"));
    return allLinks;
    
    function wrapAndFilter(newL,original) {
      var l=new XPCNativeWrapper(original,'getAttribute()');
      var url=l.getAttribute("src");
      if(!url) return false;
      newL.href=urlResolver.resolve(url);
      var des=l.getAttribute("alt");
      if(!des) des=l.getAttribute("title");
      if(!des) des=url.substring(url.lastIndexOf("/")+1);
      var w=l.getAttribute("width");
      var h=l.getAttribute("height");
      if(w && h) {
        des+=" ("+w+","+h+")";
      }
      newL._description=des;
      return filter(newL,original);
    }
    
    function filterLinks(elems,filter,tagName) {
      const links=new Array();
      wrap=tagName=="a";
      try {
        elems=flashGot.wrapCollection(elems);
        if(elems) {
          var l,newL;
          for(var j=0,len=elems.length; j<len; j++) {
            l=elems.item(j);
            newL=wrap?flashGot.wrapAnchor(l):{ tagName: tagName };
            if(filter(newL,l)) {
              links[links.length]=newL;
            }
          }
        }
      } catch(ex) {}
      return links;
    }
  }
,
  get referrer() {
    if(this._referrer) return this._referrer;
    var gb=this.unwrappedWindow._flashgotGB;
    return gb?gb.referrer:this.srcDocument.URL;
  }
,  
  set referrer(r) {
    return this._referrer=r; 
  }
,
  getSelectionLinks: function(includeImages) {
    var sel=this.srcWindow.getSelection();
    
    this.selection=sel;
    var links=this.getLinks(function(link,trueNode) {
      return flashGot.checkLink(link) && flashGot.selection.containsNode(trueNode?trueNode:link,true); 
    }, includeImages);
    const httpFixer=/^h.{2}p/i;
    const noprotFixer=/^([a-z]+[a-z\d]+\.[a-z\d\.]+\/)/i;
   
    const m=this.selection.toString().match(/\b(h.{2}p:\/\/|ftp:\/\/|mms:\/\/|rtsp:\/\/|[a-z]+[a-z\d]+\.[a-z\d\-\.]+\/)[^\s]*/gi);
    if(m) {
      var textLinks=new Array();
      for(var j=0, len=m.length; j<len; j++) {
        var href=m[j].replace(httpFixer,"http").replace(noprotFixer,"http://$1");
        if(href.length>0) {
          textLinks[textLinks.length]={href: href, title: m[j], innerHTML: "", tagName: "flashgottextlink"};
        }
      }
      links=links.concat(textLinks);
    }
    return links;
  }
,
  checkLink: function(link) {
    return link && link.href && /^[a-z]+:\/\/.*/i.test(link.href) && ! /^(javascript|mailto|news|file|data):/i.test(link.href);
  }
,
  wrapAnchor: function(node) {
    if(node instanceof HTMLAnchorElement) {
      try {
        return new XPCNativeWrapper(node,"href","parentNode","tagName","title","innerHTML", "getElementsByTagName()");
      } catch(ex) {}
    }
    return null;
  }
,
  findLinkAsc: function(node) {
     var anchor;
     while(node) {
      anchor=this.wrapAnchor(node);
      if(anchor) return this.checkLink(anchor)?anchor:null;
      node = new XPCNativeWrapper(node,"parentNode").parentNode;
    }
    return null;
  }
,
  downloadPopupLink: function(dmName) {
    const link=this.popupLink;
    if(link != null) {
      this.download([link], dmName);
    }
  }
,
  downloadLink: function(dmName) {
    const sel=this.srcWindow.getSelection();
    var link=this.wrapAnchor(sel.anchorNode);
    if(!link) {
      link=this.findLinkAsc(this.hoverElement);
    }
    return link?this.download([link], g_flashGotService.OP_ONE, dmName):false;
  }
,
  downloadSel: function(dmName) {
    if(this.isSelInvalid) return false;
    return this.download(
      this.getSelectionLinks(g_flashGotService.getPref("includeImages")), 
      g_flashGotService.OP_SEL,dmName);
  }
,
  downloadAll: function(dmName) {
    const links=this.getLinks(
      this.checkLink,
      g_flashGotService.getPref("includeImages"));
    return this.download(links, g_flashGotService.OP_ALL, dmName);
  }
,
  autotest: function() {
   
    const ps = Components.classes["@mozilla.org/embedcomp/prompt-service;1"
      ].getService(Components.interfaces.nsIPromptService);


    var flags=ps.BUTTON_OK * ps.BUTTON_POS_0 +
          ps.BUTTON_TITLE_IS_STRING * ps.BUTTON_POS_1 +
          ps.BUTTON_TITLE_CANCEL  * ps.BUTTON_POS_2;

    const dms=g_flashGotService.DMS;
    const ops={
      Link: this.downloadLink, 
      Selection: this.downloadSel,
      All: this.downloadAll 
    };
    var dm,opName,res,opFunc;
    for(var j=dms.length; j-- >0;) {
      dm=dms[j];
      if(dm.supported) {
        for(opName in ops) {
          res=ps.confirmEx(window,"FlashGot Autotest",
                  "Performing FlashGot "+opName+" on "+dm.name,
                  flags, null, "Skip", null, null, {});
          if(res==0) {
            opFunc=ops[opName];
            try {
              opFunc.call(this,dm.name);
            } catch(ex) {
              alert("Error:\n"+ex.message);
              throw ex;
            }
          } else if(res==2) return;
        }
      }
    }
  }
,
  download: function(links, opType, dmName) {
    links.document=this.srcDocument;
    links.referrer=this.referrer;
    const ret=g_flashGotService.download(links, opType, dmName);
    if(ret && links.progress) {
      this.showProgress(links.progress);
    }
    return ret;
  }
,
  progressList: []
,
  showProgress: function(pg) {
    
    function display(v) {
      collapsed=v<100?"false":"true";
      document.getElementById("flashgot-progresspanel").setAttribute("collapsed",collapsed);
      document.getElementById("flashgot-progressmeter").value=v;
    }
    
    const pgl=this.progressList;
    var len=pgl.length;
    var schedule=false;
    if(typeof(pg)=="object") {
      schedule=!len;
      pgl[len]=pg;
    } else if(len>0) {
      schedule=true;
      var value=0;
      for(var j=len; j-->0;) {
        var v=pgl[j].value;
        if(v<100) {
          value+=v;
        } else {
          pgl.splice(j,1);
          len--;
        }
      }
      display(len>0?Math.round(value/len):100);
    } else {
      display(100);
    }
   
    if(schedule) {
      window.setTimeout(function() {
        flashGot.showProgress(false)
      },100);
    }
  }
,
  buildGallery: function() {
    var previewURL=null, contentURL=null;
    var win=this.unwrappedWindow;
    if(win._flashgotGB) {
      previewURL=win._flashgotGB.previews;
      contentURL=win._flashgotGB.contents;
    } else {
      var links=this.getSelectionLinks(true);
      if(!(links && links.length)) {
         links=(links=this.popupLink)?[links]:this.srcDocument.links;
      }
      var len;
      if(links && (len=links.length)) {
        var previewRX=/\d+.*\.(jpg|jpeg|png|gif|bmp)(\?|$)/i;
        var contentRX=/\d+.*\.[a-z]{2,4}(\?|$)/i;
        var l,tag,url,imgs,i;
        for(var j=0; j<len && ! (contentURL && previewURL); j++) {
          l=links[j];
          tag=l.tagName.toLowerCase();
          url=l.href;
          if(tag!="img" && contentRX.test(url)) {
            contentURL=url;
            if(tag=="a" && l.getElementsByTagName ) {
              imgs=this.wrapCollection(l.getElementsByTagName("img"));
              for(i=0; i<imgs.length; i++) {
                var img=new XPCNativeWrapper(imgs.item(i),"src");
                if(previewRX.test(img.src)) {
                  previewURL=img.src;
                  break;
                }
              }
            }
          }
        }
        if( (!previewURL) && (tag=="img" || previewRX.test(url)) ) {
          previewURL=url;
        } 
      }
      if(!previewURL) previewURL="";
      if(previewURL && !contentURL) contentURL=previewURL;
    }
    window.openDialog("chrome://flashgot/content/flashgotGalleryBuilder.xul","_blank",
      "chrome,dialog,centerscreen,resizable",
      { 
        previewURL: previewURL, 
        contentURL: contentURL, 
        referrerURL: this.referrer,
        originalWindow: window,
        tmpDir: g_flashGotService.tmpDir,
        prefs:  g_flashGotService.globals.prefs
      }
    );
  }
 
}



window.addEventListener("load",  
  function(loadEv) {
    new FlashGot();
  }, false);



